/*
 * jPipette 2.0.1
 *
 * jQuery Plugin to pick colors from images
 *
 * Copyright (c) 2011 Ayman Teryaki
 * Havalite CMS (http://havalite.com/)
 * MIT style license, FREE to use, alter, copy, sell, and especially ENHANCE
 *
 *
 */
 
(function($) {

    $.fn.jPipette = function(options) {
		
		var set = $.extend({
			colorFormat: 'RGB',
			showPalette: true,
			palette: ['fff', 'ccc', 'C0C0C0', '999999', '666666', '333333', '000000', 'FFCCCC', 'FF6666', 'FF0000', 'CC0000', '990000', '660000', 'FFFFCC', 'FFFF33', 'FFCC99', 'FF9900', 'FF6600', 'CC9933', '999900', '666600', '006600', '009900', '33CC00', '33FF33', '99FF99', 'CCFFFF', '66FFFF', '33CCFF', '3333FF', '000099', '6600CC', '9999FF', 'CCCCFF', 'FFCCFF', 'FF99FF', 'CC33CC', '993399', '663366'],
			screenshot: 300
		}, options);

		// build menu ...............
		var bgColor = $('body').css('background-color');
		if(bgColor == 'transparent' || bgColor == 'rgba(0, 0, 0, 0)') $('body').css({'background-color':'#fff'});
		
		var jpSave = '', rgbChk = '', hexChk = '', colForm = set.colorFormat.toLowerCase(), newScreen = set.screenshot;
		
		if(colForm == 'rgba' || colForm == 'rgb') rgbChk = ' checked';
		else hexChk = ' checked';
		
		if(set.screenshot){
			jpSave = '<div id="jpSave" title="Create a screenshot of your site?"></div>';
		}
		
		var jpipetteWin = '<div id="jpipette"> <div id="jpHead"> <div id="jpLogo"><img style="width:25px; height:25px;" src="inc/images/jPipette.png" width="25" height="25"></div> <div id="jpTitle">jPipette 2</div> <div id="jpClose"><img src="inc/images/close.png" style="width:20px; height:20px;" id="jpClose"></div> </div> <div id="jpMiddle"> <div id="jcap"> <div id="jimage"> </div> </div> <div id="jInner"> <input type="text" id="rgbVal" /> <label> <input type="radio" name="jFormat" id="jFormat" value="rgbVal"' + rgbChk + ' />rgb</label><br> <input type="text" id="hexVal" /> <label> <input type="radio" name="jFormat" id="jFormat" value="hexVal"' + hexChk + ' />hex</label> <div id="jpSlider"> <input type="range" min="0" max="10" value="10" id="jpFader" /> <input type="hidden" id="jamount" value="1"> ' + jpSave + '</div> </div> </div> <div id="jpFooter"></div> </div>';
		$('body').append(jpipetteWin);
		
		var jpnc = '';
		for(var i=0; i<13; i++){ jpnc += '<div class="jcol"><div id="jcol_' + i + '"></div></div>';	}
		
		if(set.showPalette && $.isArray(set.palette)){
			for(var i=0; i<set.palette.length; i++){ jpnc += '<div class="jcol"><div style="background-color:#' + set.palette[i] + '"></div></div>'; }
		}
		$('#jpFooter').append(jpnc);
		
		$('#jpipette').draggable();
		
		$('#jpClose').click(function(){
			 $('#jpipette').hide();
			 $('.jPipImg').remove();
		});
		
		var handler = '', iHandler = 0;
		
		// each start ......................
		this.each( function(i, n) { 
			var button = '<img src="inc/images/pipettex.png" id="jbutton' + i + '" class="jbutton">';
			$(button).insertAfter($(this));
			$('#jbutton'+i).click( function(){
				handler = '';
				iHandler = i;
				if(n) handler = n.nodeName;
				
				renderPage(set.screenshot); 
			})
		});
		
		// localStorage .................
		function jStore(val){
			var x = '#jcol_';
			if(val != localStorage.getItem(x + '0')){
				for(var i=12; i>=0; i--){
					if(val){
						if(localStorage.getItem(x + i) == null) localStorage.setItem(x + i, val)
						if(i==0){
							localStorage.setItem(x + i, val);
							$(x + i).css({'background-color': localStorage.getItem(x + i) });
						}
						else{
							localStorage.setItem(x + i, localStorage.getItem(x  + (i-1)));
							$(x + i).css({'background-color': localStorage.getItem(x + (i-1)) });
						}
					}
					else{
						$(x + i).css({'background-color': localStorage.getItem(x + i) });
					}
				}
			}
		}
		
		// rgb data to hex ...............
		function col2hex(c) {
			var hex = c.toString(16);
			return hex.length == 1 ? "0" + hex : hex;
		}
		
		// fix float opacity by chrom and rgb to rgba ..............
		function chromFix(val){
			if(val.match(/rgb[ ]*\(/)){
				val = val.replace(/rgb[ ]*\(/g, "rgba(");
				val = val.replace(/\)/g, ", 1)");
			}
				else{var floatNr = parseFloat(val.split(',')[3], 10);
				var newNr = floatNr.toFixed(1);
				val = val.replace(new RegExp(floatNr, 'g'), newNr);
			}
			return val;
		}
		
		// render canvas with html2canvas .....................
		function renderPage(screenshot){
			var bgColor = $('body').css('background-color');
			html2canvas(document.body, { background:bgColor,
				onrendered: function(canvas) {
					
					$(canvas).attr('class', 'jPipImg');
					$('body').append(canvas);
					
					$('#jpipette').show();
					$('#jpipette').css({'z-index':'999'})
					$('.jPipImg').mousemove(function(event){
						var trans = $("#jamount").val();
						
						var x = event.pageX - this.offsetLeft;
						var y = event.pageY - this.offsetTop;
						
						var ctx = canvas.getContext('2d');
						var dt = ctx.getImageData(x,y,1,1);
						var jrgba = 'rgba('+dt.data[0]+', '+dt.data[1]+', '+dt.data[2]+', ' + trans + ')';
						
						var jhex = "#" + col2hex(dt.data[0]) + col2hex(dt.data[1]) + col2hex(dt.data[2]);
						
						$('#jimage').css('background-color', jrgba);
						$('#rgbVal').val(jrgba);
						$('#hexVal').val(jhex);
						
						
					}).mousedown(function(){
						jStore($('#rgbVal').val());
					});
					
					// create screenshot .................
					if(screenshot){
						$('#jpSave').click(function(){
							var extra_canvas = document.createElement("canvas");
							//$(extra_canvas).attr('sytle', 'display:none;');
							
							var w = canvas.width, h = canvas.height;
							
							
							var newW = screenshot;
							var p = Math.round(100/w*newW);
							var newH = Math.round(p*h/100);
							
							extra_canvas.setAttribute('width',newW);
							extra_canvas.setAttribute('height',newH);
							var ctx = extra_canvas.getContext('2d');
							ctx.drawImage(canvas,0,0,w,h, 0,0,newW, newH);
							//$('body').append(extra_canvas);
							
							window.parent.location = extra_canvas.toDataURL("image/png");
						});
					}
				}
			});
		}
		
		// Mouse move ....................
		$('#jpFader').mousemove(function(e){
			if(e.which==1){
				var sval =  $('#jpFader').val()/10;
				var jrgb = $('#rgbVal').val();
				var jrgb = jrgb.replace(/,[ ]*[\d+|.]+\)/g, ',' + sval + ')');
				$( "#jamount" ).val( sval );
				$('#jimage').css({'background-color': jrgb });
				$('#rgbVal').val(jrgb);
			}
		});	

		// close dialog ............................
		$('.jcol div').click(function(){ 
			var format = $("input[name='jFormat']:checked").val();
			var jcolor = chromFix($(this).css('background-color'));
	
			jStore(jcolor);
			
			if(format != 'rgbVal'){
				jcolor = jcolor.replace(/(rgb[ |a]*\()|(\)[ |;]*)|[ ]*/gi, "");
				var jarr = jcolor.split(/,/);
				jcolor = '#' + col2hex(parseInt(jarr[0])) + col2hex(parseInt(jarr[1])) + col2hex(parseInt(jarr[2]));
			}
			
			
			//alert(handler+' '+iHandler+' '+jcolor);
			$(handler).eq(iHandler).val(jcolor);
			$( "#jpipette" ).hide();
			$('.jPipImg').remove();
			$(handler).eq(iHandler).focus();
		});
		jStore();
	}
}(jQuery));

